function menu_load(fromsettings, fromhighscore, fromcoop)
	state = "menu"
	
	menuscrolly = 0
	menu_batquadi = 1
	score = 0

	suspended = false 

	menu_selectioni = 1
	minselecti = 1

	if fromcoop then
		saveData("netplay")

		menu_selectioni = 2
	elseif fromsettings then
	--	savesettings()
		saveData("settings")

		menu_selectioni = 3
	elseif fromhighscore then
		saveData("highscores")

		menu_selectioni = 4
	end

	gameData = {}

	loadData("highscores")

	settings_selectioni = 1

	if audio["menu"]:isStopped() then
		--If you save the gamedata with music volume as 0, you won't hear it on settings
		--(going up or down) until you reload the menu. This is a quick fix, but works
		
		audio["menu"]:stop()
		audio["menu"]:play()
		--playsound("menu")
	end

	love.audio.stop(audio["boss"])
	love.audio.stop(audio["finalboss"])

	menu_battimer = 0

	gameover = false

	menu_items = 
	{
		{t = "New Game", func = partymode_load},
		{t = "Online Co-Op", func = netplay_load},
		{t = "Options Menu", func = settings_load},
		{t = "Highscores", func = function() highscoredisplay_load(true) end},
	}
end

function menu_draw(alpha)
	local a = alpha or 255

	love.graphics.setColor(255, 0, 0, a)

	love.graphics.setFont(font1.lrg)

	x = (600 * scale) / 2

	love.graphics.print("Turtle:", x-font1.lrg:getWidth("Turtle:")/2, 36*scale)

	love.graphics.setColor(0, 255, 0, a)
	love.graphics.setFont(font1.xl)
	love.graphics.print("Invaders", x-font1.xl:getWidth("Invaders")/2, 76*scale)

	love.graphics.setColor(255, 255, 255, a)
		
	love.graphics.setFont(font3)
	love.graphics.print("(C) 2015 Tiny Turtle Industries", x-font3:getWidth("(C) 2014 Tiny Turtle Industries")/2, 120*scale)

	
	love.graphics.setFont(menubuttonfont)
	
	local batx = math.floor(x-menubuttonfont:getWidth(menu_items[menu_selectioni].t)/2)
			
	love.graphics.draw(graphics["bat"], batquads[menu_batquadi], batx-32*scale, (182 + (menu_selectioni - 1) * 30) * scale,0, scale, scale)
	love.graphics.draw(graphics["bateyes"], batquads[menu_batquadi], batx-32*scale, (182 + (menu_selectioni - 1) * 30) * scale,0, scale, scale)

	for k = 1, #menu_items do
		love.graphics.print(menu_items[k].t, x - menubuttonfont:getWidth(menu_items[k].t) / 2, (182 + (k - 1) * 30) * scale)
	end

	--KEEP THIS BECAUSE MENU THINGS IN SETTINGS IDK WHY
	love.graphics.setFont(font3)
end

function menu_update(dt)
	menu_battimer = math.min(menu_battimer + 8*dt)
	menu_batquadi = math.floor(menu_battimer%3)+1
end

function menu_keypressed(k)
	if k == "s" or k == "down" then
		menu_movecursor(true)
	end

	if k == "w" or k == "up" then
		menu_movecursor(false)
	end

	if k == "return" or k == " " then
		menu_movecursor(nil, nil, true)
	end
		
	if k == "escape" then
		menu_movecursor(nil, nil, false)
	end
end

function menu_joystickaxis(joystick, axis, value)

end

function menu_joystickpressed(joystick, button)
	if button == "a" then
		menu_movecursor(nil, nil, true)
	end

	if button == "dpdown" then
		menu_movecursor(true)
	elseif button == "dpup" then
		menu_movecursor(false)
	end

	if button == "b" then 
		love.event.push("quit")
	end
end

function menu_movecursor(down, right, enter)
	if  down ~= nil then
		if down then
			if menu_selectioni < #menu_items then
				menu_selectioni = menu_selectioni + 1
			end
		else --up
			if menu_selectioni > minselecti then
				menu_selectioni = menu_selectioni - 1
			end
		end
	end

	if enter ~= nil then
		if enter then
			if menu_items[menu_selectioni].func then
				menu_items[menu_selectioni].func()
			end
		else
			local button = love.window.showMessageBox(love.window.getTitle(), "Are you sure you want to quit?", {"No", "Yes"}, "info", true )

			if button == 2 then
				love.event.quit()
			end
		end
	end
end